%define current_version 7.0.126
%define _incdir /usr/include/ploop
%define _scriptdir %{_libexecdir}/%{name}
Summary: ploop tools
Name: ploop
Version: %{current_version}
Release:        1%{?dist}
Group: Applications/System
License: GPLv2
Source: %{name}-%{version}.tar.bz2
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: ploop-lib = %{version}-%{release}
BuildRequires: libxml2-devel libuuid-devel openssl-devel json-c-devel
BuildRequires: e2fsprogs-devel
ExclusiveArch: x86_64

%description
This package contains tools to work with ploop devices and images.

%package lib
Summary: ploop library
Group: Applications/System
License: LGPLv2.1
Requires: libxml2
Requires: parted gdisk
Conflicts: vzkernel < 2.6.32-042stab061.1
Requires: util-linux
Requires: e2fsprogs
Requires: lsof
Requires: findutils
Conflicts: vzctl < 4.5

%description lib
OpenVZ loopback (ploop) block device API library

%package devel
Summary: Headers for development with ploop library
Group: Applications/System
License: GPLv2 or LGPLv2.1
Requires: pkgconfig

%description devel
Headers and a static version of ploop library

%package -n python-%{name}
Summary: Python bindings for %{name}
Group: Development/Languages
Requires: %{name}-lib = %{version}-%{release}
Requires: python2 >= 2.7
BuildRequires: python2-devel >= 2.7

%description -n python-%{name}
python-%{name} contains Python bindings for %{name}.

%prep
%setup -q

%build
make %{?_smp_mflags} LIBDIR=%{_libdir} PLOOP_LOG_FILE=/var/log/ploop.log all

%install
rm -rf %{buildroot}
make DESTDIR=%{buildroot} LIBDIR=%{_libdir} PLOOP_LOG_FILE=/var/log/ploop.log install install-licenses

%clean
rm -rf %{buildroot}

%post lib -p /sbin/ldconfig

%postun lib -p /sbin/ldconfig

%triggerin lib -- systemd
SCRIPT="/lib/udev/rules.d/60-persistent-storage.rules"
if [ -f $SCRIPT ]; then
	fgrep 'KERNEL=="ploop*", GOTO="persistent_storage_end"' $SCRIPT > /dev/null 2>&1 ||
	sed -i -e '1 s/^/KERNEL=="ploop*", GOTO="persistent_storage_end"\n/;' $SCRIPT
fi

%files
%attr(755,root,root) /sbin/*
%attr(755,root,root) %{_sbindir}/ploop
%attr(755,root,root) %{_sbindir}/ploop-*
%attr(644,root,root) /etc/logrotate.d/ploop
%attr(644, root, root) %config %{_sysconfdir}/modules-load.d/ploop.conf
%attr(644,root,root) %{_mandir}/man8/ploop.8.*
%{_docdir}/%{name}-%{version}

%files lib
%defattr(-,root,root)
%attr(755,root,root) %{_libdir}/libploop.so.*
%dir /var/lock/ploop
%{_prefix}/lib/tmpfiles.d/%{name}.conf
%{_docdir}/%{name}-lib-%{version}
%dir %{_scriptdir}
%{_scriptdir}/*

%files devel
%defattr(-,root,root)
%dir %{_incdir}
%attr(644,root,root) %{_libdir}/libploop.a
%{_libdir}/pkgconfig/ploop.pc
%{_libdir}/libploop.so
%attr(644,root,root) %{_incdir}/libploop.h
%attr(644,root,root) %{_incdir}/libvolume.h
%attr(644,root,root) %{_incdir}/ploop_if.h
%attr(644,root,root) %{_incdir}/ploop1_image.h
%attr(644,root,root) %{_incdir}/dynload.h
%{_docdir}/%{name}-devel-%{version}

%files -n python-%{name}
%dir %{python2_sitearch}/libploop
%{python2_sitearch}/libploop/*
%{python2_sitearch}/*.egg-info

%changelog
* Mon Feb 19 2018 Igor Sukhih <igor@virtuozzo.com> 7.0.126
 - cbt_set_dirty_bitmap_part(): endless loop

* Wed Feb 14 2018 Igor Sukhih <igor@virtuozzo.com> 7.0.125
 - cannot create ploop with ext4 on a drive with 4k logical sector size
\#PSBM-81545

* Wed Feb 07 2018 Igor Sukhih <igor@virtuozzo.com> 7.0.124
 - ploop-grow: don't fill a raw image if the sparse option is set (Andrei Vagin
<avagin@openvz.org>)

* Mon Jan 29 2018 Igor Sukhih <igor@virtuozzo.com> 7.0.123
 - ploop: allow to replace a raw read-write delta (Andrei Vagin
<avagin@openvz.org>)

* Mon Jan 22 2018 Igor Sukhih <igor@virtuozzo.com> 7.0.122
 - mount failed with: stat /dev/mapper/CRYPT-ploop50869p1: No such file or
directory #PSBM-80502

* Fri Jan 19 2018 Igor Sukhih <igor@virtuozzo.com> 7.0.121
 - ploop: allow to create a sparse file as a plain image (Andrei Vagin
<avagin@openvz.org>)

* Wed Dec 20 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.120
 - Extend ploop size limit 50T #PSBM-79604

* Tue Dec 19 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.119
 - free_ext_context(): NULL pointer dereference

* Tue Dec 19 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.118
 - send_dirty_bitmap_to_kernel(): double free

* Thu Dec 14 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.117
 - Memory leak in CBT code

* Wed Dec 13 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.116
 - dump_L1(): make output user friendly
 - raw_move_to_memory(): memleak on error path
 - Get tracking bitmap from image #PSBM-77973

* Tue Dec 12 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.115
 - ploop_clone_dd(): do not convert DiskDescriptor.xml
 - ploop_clone_dd(): drop temporary bit
 - Get used block bitmap #PSBM-53844

* Fri Dec 08 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.114
 - Clone DiskDescriptor.xml

* Fri Nov 24 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.113
 - Add ploop_drop_cbt() to public API

* Mon Oct 23 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.112
 - ploop_resize_image(): incorrect fs info reported ofter offline shrink
\#PSBM-75100

* Mon Oct 23 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.111
 - get_image_param_offline(): use OD_ALLOW_DIRTY for open_delta #PSBM-75809

* Tue Oct 17 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.110
 - get_partition_device_name_by_num(): use /sys/class/block to query partiton
\#PSBM-75261

* Fri Oct 06 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.109
 - ploop_init_image(): unable to recreate encrypted image #PSBM-71894

* Mon Oct 02 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.108
 - Error in do_lock: Can't open lock file: Device or resource busy #PSBM-73316

* Mon Sep 25 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.107
 - parse_xml(): check for KeyId != NULL

* Fri Sep 22 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.106
 - Export ploop_init_image() #PSBM-71894

* Fri Sep 15 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.105
 - volume: allow to use existing directoy for a new volume

* Tue Aug 29 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.104
 - ploop-volume killed by SIGSEGV #VZAP-652

* Mon Aug 28 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.103
 - ploop-volume: add struct size argument for get_info/get_tree
 - ploop-volume: make tree and info commands print result in json
 - ploop-volume: add tree command line option and API
 - ploop-volume: add info command line option and API

* Wed Aug 23 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.102
 - ploop_trim(): endless loop on FITRIM #PSBM-70551

* Wed Aug 23 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.101
 - ploop_get_dev_by_delta: unable to find mounted ploop device

* Mon Aug 21 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.100
 - revert fd88e52d30 ploop_stop_device: retry PLOOP_IOC_STOP on EBUSY
\#PSBM-69753

* Thu Aug 17 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.99
 - ploop_stop_device(): return with SYSEXIT_UMOUNT_BUSY on error #PSBM-69753

* Thu Aug 10 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.98
 - ploop_stop_device: retry PLOOP_IOC_STOP on EBUSY #PSBM-69753

* Wed Aug 09 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.97
 - ploop_find_dev_by_cn(): use only base delta to find ploop device #PSBM-69781
 - volume: mark volume based layout in DiskDeskriptor.xml
 - Failed to provison volume if some of ploop modules are not loaded #VZAP-474

* Mon Aug 07 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.96
 - add_deltas(): NULL dereference #PSBM-69755

* Fri Aug 04 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.95
 - Makefile: install libvolume.h

* Fri Aug 04 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.94
 - Use open() with O_CLOEXEC flag
 - test: ploop-volume
 - ploop-volume: add command line tool
 - ploop volumes API
 - Dont store parent data in DiskDescriptor.xml
 - Mount file system in ro mode for snapshots
 - Always store relative path in DIskDescriptor.xml
 - ploop_find_dev_by_cn(): search ploop dev by pair (base & top) deltas
 - Introduce volume specific metadata

* Wed Jul 19 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.93
 - Can't mount: Device or resource busy #PSBM-68599

* Mon Jun 26 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.92
 - ploop_umount(): do not stop CBT on ploop_stop error
 - Configure umount timeout #PSBM-67574

* Mon Jun 26 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.91
 - ploop_stop(): return EBUSY specific error #PSBM-67574

* Wed Jun 07 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.90
 - Export ploop_get_top_delta_fname to python API #PSBM-67091

* Thu Jun 01 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.89
 - Ability to tune inode_ratio #PSBM-62212

* Tue Apr 18 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.88
 - Add option to set filesystem label

* Wed Mar 29 2017 Konstantin Volkov <wolf@virtuozzo.com> 7.0.87
 - Fix Copyright strings, see #PSBM-58317

* Wed Mar 29 2017 Konstantin Volkov <wolf@virtuozzo.com> 7.0.86
 - Fix Copyright strings, see #PSBM-58317 (Igor Sukhih <igor@virtuozzo.com>)

* Wed Mar 22 2017 Konstantin Volkov <wolf@virtuozzo.com> 7.0.85-2
- Added gdisk package to reqs, see #PSBM-62710

* Tue Mar 21 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.85
 - cbt_dump(): skip CBT dump if not running

* Tue Mar 21 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.84
 - preserve CBT on offline snapshot creation #PSBM-62562
 - tools/ploop-cbt.c: show dump usage
 - tools/ploop.c: added -o - offline snapshot creation

* Tue Mar 07 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.83
 - Remove -fsanitize=address from CFLAGS #PSBM-61727

* Mon Mar 06 2017 Konstantin Volkov <wolf@virtuozzo.com> 7.0.82-3
- Place package definitions and files lists in right order
- Move license installation inside sources Makefile, see #PSBM-58317

* Mon Mar 06 2017 Konstantin Volkov <wolf@virtuozzo.com> 7.0.82-2
- Added libasan to BuildRequires

* Mon Mar 06 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.82
 - Move branding to separate file, see #PSBM-58317
 - Add licenses installation (Konstantin Volkov

* Fri Mar 03 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.81
 - get_part_devname_from_sys(): AddressSanitizer heap-buffer-overflow #PSBM-54889

* Mon Feb 20 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.80
 - Unable to delete tsnapshot #PSBM-59212

* Wed Jan 11 2017 Igor Sukhih <igor@virtuozzo.com> 7.0.79
 - ploop.8: fix typos (Kir Kolyshkin <kir@openvz.org>) (#PSBM-58292)
 - ploop_restore_descriptor: fix clang compilation (Kir Kolyshkin
<kir@openvz.org>)
 - Modify get_partition_device_name (Mikhail Feoktistov
<mfeoktistov@virtuozzo.com>)
 - Rename variable (Mikhail Feoktistov <mfeoktistov@virtuozzo.com>)

* Wed Dec 14 2016 Konstantin Volkov <wolf@virtuozzo.com> - 7.0.78-2
- Rebuild in 7.3 environment

* Tue Nov 29 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.78
 - libploop.h: move PLOOP_MAX_FS_SIZE to public header

* Tue Oct 25 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.77
 - Introduce SYSEXIT_UMOUNT_BUSY error #PSBM-54005

* Wed Oct 19 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.76
 - Failed to resize image: On-line shrinking not supported #PSBM-54003

* Wed Oct 19 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.75
 - Turn off console logging for 'balloon discard --stat'
 - 'ploop balloon discard --stat' does not work on not mounted image #PSBM-53998

* Fri Oct 07 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.74
 - Rewrite crypthelper in python #PSBM-53278

* Thu Oct 06 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.73
 - crypthelper: process key from STDIN in file mode in cryptsetup #PSBM-53205

* Wed Oct 05 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.72
 - Use custom script to get encryption key #PSBM-52949 #PSBM-53053
 - rename crypt.sh -> crypthelper
 - pcompact timeout doesn't affect defragmenttaion #PSBM-41298

* Fri Sep 30 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.71
 - revert commit bd46a066 "use session keyring to load key" #PSBM-52965

* Fri Sep 30 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.69
 - crypt.sh: use session keyring to load key #PSBM-52949
 - Use O_CLOEXEC on device open

* Tue Sep 27 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.68
 - Failed to resize: Can't fallocate balloon #PSBM-49371

* Tue Sep 27 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.67
 - ploop.8: add encryption info
 - revert commit e35d4a0f6 (#PSBM-52358)
 - encrypt_image: deny encrypt running ploop

* Tue Sep 20 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.66
 - encrypt_image: decript image

* Tue Sep 20 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.65
 - crypt,sh: keyctl_read_alloc: Permission denied #PSBM-52358

* Tue Sep 20 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.64
 - crypt.sh: fixed result code check

* Mon Sep 19 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.63
 - crypt.sh: debug logging #PSBM-52289

* Fri Sep 16 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.62
 - crypt: Device /dev/dm-4 is still in use #PSBM-52258
 - Use partprobe instead of sending ioctl for LVM

* Fri Sep 16 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.61
 - do_crypt: fix using run_prg_rc()

* Fri Sep 16 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.60
 - crypt: dump key info on key retrival failure #PSBM-52202
 - Return SYSEXIT_CRYPT specific error on crypt.sh failure
\#PSBM-52241

* Fri Sep 16 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.59
 - Error in ioctl(BLKDISCARD): Invalid argument #PSBM-52241

* Thu Sep 15 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.58
 - crypt.c: invert change key logic
 - scripts/crypt.sh: return action specific erro codes
 - ploop_encrypt_param: add PLOOP_ENC_WIPE flags
 - Change encryption key #PSBM-52087

* Wed Sep 14 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.57
 - crypt.sh: equest_key: Key has been revoked #PSBM-52134

* Wed Sep 14 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.56
 - plooptool_info: diplay partition device name #PSBM-51859

* Mon Sep 12 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.55
 - crypt.sh: Load key to default user session keyring @us #PSBM-51923

* Fri Sep 09 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.54
 - ploop_set_encryption_keyid(): add operation lock
 - get_dir_entry(): do not fail on ENOENT
 - Fix cleanup in ploop_create_image 

* Mon Sep 05 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.53
 - Add functions to resize partition on block device 
 - Add functions to work with parted and sgdisk utilities
 - Add ability to initialize block device via ploop init #PSBM-473771

* Tue Aug 30 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.52
 - Invalid CBT in the image #PSBM-51513

* Fri Aug 26 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.51
 - ploop_store_diskdescriptor(): devide by zero #PSBM-51427

* Tue Aug 23 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.50
 - Preserve xattr on ploop encryption #PSBM-51074
 - change ploop_encrypt_image() API

* Mon Aug 22 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.49
 - ploop_get_mnt_by_dev(): access to uninitialized memory #PSBM-51168
 - ploop_encrypt_image(): wipe image on encryption failure #PSBM-50724
 - Update usage messages (Mikhail Feoktistov <mfeoktistov@virtuozzo.com>)

* Thu Aug 18 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.48
 - Unable to unmount disconnected ploop images #PSBM-51110

* Wed Aug 17 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.47
 - fix ploop_get_mnt_by_dev() to work with encrypted images
 - Pass --allow-discards option to 'cryptsetup open'
 - Take into account luks header on crypted ploop #PSBM-51037

* Tue Aug 16 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.46
 - ploop_get_info(): don't work for mounted ploop #PSBM-50945

* Tue Aug 16 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.45
 - Remove --xattrs option from rsync

* Fri Aug 12 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.44
 - Failed to mount ploop #PSBM-50937

* Thu Aug 11 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.43
 - Makefile: install cryptsetup helper script
 - plooptool_init(): process encryption keyid on init action
 - Encrypt/decrypt ploop image
 - Store encryption keyid at DiskDescriptor.xml #PSBM-49384
 - partition device name getter
 - get_mntns_mount_dir(): make function generic
 - LUKS disk encryption support
 - run_prg_rc(): pass environment variables on exec
 - Disk encryption: init/mount/umount/resize #PSBM-44166

* Thu Jul 21 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.42
 - Call PLOOP_IOC_FREEZE on partition #PSBM-49837

* Thu Jul 21 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.41
 - ploop_get_dev_by_delta(): ignore realpath() error #PSBM-49902

* Fri Jul 15 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.40
 - USe new ioctl to freeze ploop device #PSBM-49179
 - ploop_if.h: add PLOOP_IOC_FREEZE and PLOOP_IOC_THAW ioctls
 - Disk encryptuin: add keyid parameter to DiskDescriptor.xml

* Thu Jun 30 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.39
 - ploop_copy_receiver: truncate image on dst #PSBM-49076

* Fri Jun 17 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.38
 - Create .statfs and DiskDescriptor.xml.lck with 644 mode (v2) #PSBM-48352

* Thu Jun 16 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.37
 - Create .statfs and DiskDescriptor.xml.lck with 644 mode #PSBM-48352

* Fri Jun 10 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.36
 - Update ploop_if.h header to the latest kernel version
 - Error in ploop_fname_cmp (ploop.c:1129): No such file or directory

* Thu Jun 02 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.35
 - Add ploop_read_dd() to public API

* Fri May 27 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.34
 - ploop-copy.c: u32 passed as u64 to send_image_block() #PSBM-47575

* Thu May 26 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.33
 - ploop-copy: CBT live migration #PSBM-47128
 - Fix close of 0 descriptor in case of error in grow_lower_delta. #PSBM-47329

* Tue May 24 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.32
 - send_image_block (ploop-copy.c:480): Error from read: Bad address #PSBM-46720

* Mon May 23 2016 Igor Sukhih <igor@virtuozzo.com> 7.0.31
 - Port CBT support from PSBM6

* Fri May 13 2016 Dmitry Mishin <dim@virtuozzo.com> 7.0.30
 - Sync ploop_if.h with the latest kernel version (#PSBM-45001)
 - Add --defrag flag for usage and man (Kir Kolyshkin <kir@openvz.org>)
 - include/dynload.h: version for ploop_get_base_delta_fname() (Kir Kolyshkin
<kir@openvz.org>)
 - ploop_discard(): nitpick in a comment (Kir Kolyshkin <kir@openvz.org>)
 - get_delta_fname: make static (Kir Kolyshkin <kir@openvz.org>)

* Thu Apr 21 2016 Igor Sukhih <igor@parallels.com> 7.0.29
 - discard/defrag: take into account image size change caused by defrag #PSBM-42548 #PSBM-45364
 - Unable to create ploop image > 16TB without filesystem inside #PSBM-45162

* Sat Apr 16 2016 Igor Sukhih <igor@parallels.com> 7.0.28
 - ploop discard operation cancelled on fs defragmentation error #PSBM-46198

* Fri Apr 15 2016 Igor Sukhih <igor@parallels.com> 7.0.27
 - Lock descriptor before accessing it in ploop_get_*_delta_fname() #PSBM-45496

* Fri Apr 15 2016 Igor Sukhih <igor@parallels.com> 7.0.26
 - api to get base delta file name #PSBM-46238

* Thu Apr 14 2016 Igor Sukhih <igor@parallels.com> 7.0.25
 - ploop-copy: Ploop image coruption  #PSBM-45837

* Wed Apr 13 2016 Igor Sukhih <igor@parallels.com> 7.0.24
 - ploop_copy_init(): open folder with O_DIRECTORY flag
 - send_async(): use pthread_cond_signal() under lock
 - Rework check_snapshot_mount()
 - ploop_merge_snapshot_by_guid(): improve messages 

* Tue Mar 29 2016 Igor Sukhih <igor@parallels.com> 7.0.23
 - add ploop_create_snapshot_offline() #PSBM-42981

* Thu Mar 24 2016 Igor Sukhih <igor@parallels.com> 7.0.22
 - python: Add snapshot create/delete bindings
 - python: fix error message for PyArg_ParseTuple()
 - do_mntn_merge(): fix the check for same file
 - complete_running_operation(): unexport

* Wed Feb 24 2016 Igor Sukhih <igor@parallels.com> 7.0.21
 - Fix statistics returned during ploop copying, #PSBM-41177
 - ploop_mount_fs(): rectify wrt remount
 - ploop_mount_fs: don't mount ro when finding balloon inode

* Wed Feb 10 2016 Igor Sukhih <igor@parallels.com> 7.0.20
 - Repair DiskDescriptot.xml on process PLOOP_MNTN_MERGE stage #PSBM-33414
 - Makefile: .depend file is not removed on 'make clean'
 - mount_image(): kill flags argument
 - Fix compile with gcc-5.3.0
 - Fix compile with musl wrt gnu_dev_*
 - Fix compile with musl wrt offsetof
 - gensym.sh: busybox sed compatibility

* Thu Feb 04 2016 Igor Sukhih <igor@parallels.com> 7.0.19
 - ploop_umount(): possible NULL pointer derefference
 - Rmove temporary mount point on ploop umount #PSBM-42493
 - Remove temporary mount point on offline ploop resize #PSBM-42493
 - Remove temporary mount point on ploop umount #PSBM-42493

* Tue Jan 26 2016 Igor Sukhih <igor@parallels.com> 7.0.18
 - Remove temporary mount point on offline ploop resize #PSBM-42493

* Fri Jan 22 2016 Igor Sukhih <igor@parallels.com> 7.0.17
 - Remove temporary mount point on ploop umount #PSBM-42493

* Fri Jan 15 2016 Igor Sukhih <igor@parallels.com> 7.0.16
 - Directory root.hds.mnt is left after container resize #PSBM-42493

* Wed Nov 11 2015 Igor Sukhih <igor@parallels.com> 7.0.15
 - ploop balloon discard infinite loop #PSBM-40948

* Mon Oct 26 2015 Igor Sukhih <igor@parallels.com> 7.0.14
 - Resize ploop image mounted inside mnt namespace #PSBM-39492

* Tue Oct 20 2015 Igor Sukhih <igor@parallels.com> 7.0.13
 - mount_image: return SYSEXIT_NOSNAP error, #PSBM-38423

* Fri Oct 09 2015 Igor Sukhih <igor@parallels.com> 7.0.12
 - ploop defragmentation support #PSBM-30163

* Wed Oct 07 2015 Igor Sukhih <igor@parallels.com> 7.0.11
 - do_delete_snapshot: pass copy of guid parameter
 - ploop_get_devs: NULL pointer dereference, #PSBM-40203

* Wed May 06 2015 Igor Sukhih <igor@parallels.com> 7.0.10
 - Add makefile for python bindings, #PSBM-28485

* Fri Apr 10 2015 Daniil Guzanov <dguzanov@odin.com> 7.0.9
 - Updated GPL text

* Thu Apr 09 2015 Daniil Guzanov <dguzanov@odin.com> 7.0.8
 - Updated license #PSBM-26806

* Tue Apr 07 2015 Daniil Guzanov <dguzanov@odin.com> 7.0.7
 - soname changed to libploop.so.7.0.x #PSBM-32811

* Tue Apr 07 2015 Daniil Guzanov <dguzanov@odin.com> 7.0.6
 - Revert to version number to libploop.so.1.12

* Mon Apr 06 2015 Daniil Guzanov <dguzanov@odin.com> 7.0.5
 - Move version to Makefile.version

